<template>
  <div>
    <ul class="ulMenu">
      <menu class="returnMenu">
        <li class="liReturnMenu">
          <!-- <a href='#'> -->
          <a v-on:click="returnToHome()">
            <i><font-awesome-icon :icon="['fas', 'arrow-left']" size="1x" /></i>
            <br />
            <span>Home</span>
          </a>
        </li>
        <!-- <li class="liReturnMenu"> -->
        <!--   <a v-on:click="connectChuck()"> -->
        <!--     <i -->
        <!--       ><font-awesome-icon -->
        <!--         :icon="['fas', 'fa-plug-circle-check']" -->
        <!--         size="1x" -->
        <!--       /> -->
        <!--     </i> -->
        <!--     <br /> -->
        <!--     <span>Chuck On</span> -->
        <!--   </a> -->
        <!-- </li> -->
        <!-- <li class="liReturnMenu"> -->
        <!--   <a v-on:click="disconnectChuck()"> -->
        <!--     <i -->
        <!--       ><font-awesome-icon -->
        <!--         :icon="['fas', 'fa-plug-circle-xmark']" -->
        <!--         size="1x" -->
        <!--       /> -->
        <!--     </i> -->
        <!--     <br /> -->
        <!--     <span>Chuck Off</span> -->
        <!--   </a> -->
        <!-- </li> -->
        <li class="liReturnMenu">
          <a v-on:click="configChuck()">
            <i><font-awesome-icon :icon="['fas', 'plug']" size="1x" /></i>
            <br />
            <span>Chuck</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="play()">
            <i><font-awesome-icon :icon="['fas', 'fa-play']" size="1x" /></i>
            <br />
            <span>Play</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="stop()">
            <i><font-awesome-icon :icon="['fas', 'fa-stop']" size="1x" /></i>
            <br />
            <span>Stop</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="eject()">
            <i>
              <font-awesome-icon :icon="['fas', 'fa-eject']" size="1x" />
            </i>
            <br />
            <span>Terminar</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="magicCodeGenerate()">
            <i><font-awesome-icon :icon="['fas', 'wand-magic-sparkles']" size="1x" /></i>
            <br />
            <span>Magic</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="saveCode()">
            <i><font-awesome-icon :icon="['fas', 'save']" size="1x" /></i>
            <br />
            <span>Guardar</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="undo()">
            <i><font-awesome-icon :icon="['fas', 'undo']" size="1x" /></i>
            <br />
            <span>&nbsp;&nbsp;&nbsp;Atrás&nbsp;&nbsp;&nbsp;</span>
          </a>
        </li>
        <li class="liReturnMenu">
          <a v-on:click="redo()">
            <i><font-awesome-icon :icon="['fas', 'redo']" size="1x" /></i>
            <br />
            <span>Adelante</span>
          </a>
        </li>
      </menu>
    </ul>
    <div>
      <ConnectModal
        @closeConnecModal="closeConnecModal"
        :trigger="triggerConnectModal"
      ></ConnectModal>
    </div>
  </div>
</template>

<script lang="ts">
/**
Código fuente original: Floating Circular Menu
Copyright (c) 2021 by Mojtaba Seyedi (https://codepen.io/seyedi/pen/IrDkc)

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit
persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT
NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/**

* Del anterior código fuente se ha inpirado para lograr los efectos de transición,
* los ajustes javascript son propios
* @author Johnny Cubides
*/

import { defineComponent, ref, onMounted } from "vue";
import "vue3-toastify/dist/index.css";
import * as Blockly from "@johnnycubides/blockly-catalejo/blockly";

// -- IMPORT MODALS COMPONENTS --
import ConnectModal from "./chuckFocusMenuModals/ConnectModal.vue";

import {
  // -- DEF CATALEJO EDITOR --
  TypeEditor,
  // -- BLOCKLY --
  getCodeChuckFromBlockly,
  // -- CHUCK --
  getPathChuckFile,
  startChuck,
  killChuck,
  saveChuckFile,
  addScriptChuck,
  removeAllScriptChuck,
  removeTheLastScripChuck,
  // -- LOG AND INFO --
  toastMsg,
} from "../../../host/index";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { library } from "@fortawesome/fontawesome-svg-core";
import {
  faArrowLeft,
  faUndo,
  faRedo,
  faPlay,
  faStop,
  faEject,
  faSave,
  faWandMagicSparkles,
  faPlugCircleCheck,
  faPlugCircleXmark,
} from "@fortawesome/free-solid-svg-icons";
library.add(
  faArrowLeft,
  faUndo,
  faRedo,
  faPlugCircleCheck,
  faPlay,
  faStop,
  faEject,
  faSave,
  faWandMagicSparkles,
  faPlugCircleCheck,
  faPlugCircleXmark
);

export default defineComponent({
  components: {
    "font-awesome-icon": FontAwesomeIcon,
    ConnectModal,
  },

  props: [
    "workspace",
    "editorSelected",
    "positionBufferBlockly",
    "positionBufferCodemirror",
    "fileHandle",
    "codeFromCodemirror",
  ],
  emits: ["savePrj", "magicCodeEmit"],
  setup(props, context) {
    const triggerConnectModal = ref(false);

    const returnToHome = (): void => {
      try {
        // Android.returnToHome();
        window.open("/dist/index.html", "_blank");
      } catch (Error) {
        console.log("Android.saveProject() failed", Error);
      }
    };

    const configChuck = () => {
      triggerConnectModal.value = true;
    };

    /*const connectChuck = async () => {
      toastMsg({
        data: "Iniciando chuck!",
        type: "info",
      });
      await startChuck();
    };*/

    /*const disconnectChuck = async () => {
      const ret = await killChuck();
      toastMsg({
        data: ret == 0 ? "Chuck apagado" : "No fue posible apagar chuck",
        type: ret == 0 ? "info" : "error",
      });
    };*/

    const closeConnecModal = () => {
      triggerConnectModal.value = false;
    };

    const stop = async () => {
      const ret = await removeTheLastScripChuck();
      toastMsg({
        data:
          ret == 0
            ? "Se remueve la última pieza"
            : "No fue posible remover la última pieza",
        type: ret == 0 ? "info" : "warning",
      });
    };

    const eject = async () => {
      const ret = await removeAllScriptChuck();
      toastMsg({
        data:
          ret == 0
            ? "Se remueven todas las piezas"
            : "No fue posible remover todas las piezas",
        type: ret == 0 ? "info" : "warning",
      });
    };

    const play = async () => {
      let code = "";
      if (props.editorSelected == TypeEditor.Blockly) {
        code = await getCodeChuckFromBlockly(props.workspace);
        const pathChuckFile = await getPathChuckFile(
          props.fileHandle,
          TypeEditor.Blockly,
          props.positionBufferBlockly
        );
        await saveChuckFile(pathChuckFile, code);
        const ret = await addScriptChuck(pathChuckFile);
        toastMsg({
          data: ret == 0 ? "Pieza agregada" : "No fue posible agregar la pieza",
          type: ret == 0 ? "info" : "warning",
        });
      } else if (props.editorSelected == TypeEditor.Codemirror) {
        code = props.codeFromCodemirror.value;
        const pathChuckFile = await getPathChuckFile(
          props.fileHandle,
          TypeEditor.Codemirror,
          props.positionBufferCodemirror
        );
        await saveChuckFile(pathChuckFile, code);
        const ret = await addScriptChuck(pathChuckFile);
        toastMsg({
          data: ret == 0 ? "Pieza agregada" : "No fue posible agregar la pieza",
          type: ret == 0 ? "info" : "warning",
        });
        console.log("crear función para extraer lua desde codemirror"); // TODO
      }
    };

    let codeToggle = false;
    const magicCodeGenerate = async () => {
      codeToggle = !codeToggle;
      const ret = 0; // TODO, crear validador
      context.emit("magicCodeEmit", {
        code: await getCodeChuckFromBlockly(props.workspace),
        check: codeToggle,
      });
      toastMsg({
        data:
          ret == 0
            ? "Generando código desde Blockly y pegando en el editor de texto"
            : "No fue posible generar código",
        type: ret == 0 ? "info" : "warning",
        time: 3000,
      });
    };

    const saveCode = (): void => {
      context.emit("savePrj");
    };

    const getXMLBlockly = (): string => {
      const xml = Blockly.Xml.workspaceToDom(props.workspace);
      return Blockly.Xml.domToText(xml);
    };

    const undo = (): void => {
      props.workspace.undo(false);
    };

    const redo = (): void => {
      props.workspace.undo(true);
    };

    onMounted(() => {
      // updateTypedVarModalForChuck(props.workspace);
    });

    return {
      // Methods
      returnToHome,
      saveCode,
      // connectChuck,
      // disconnectChuck,
      magicCodeGenerate,
      play,
      stop,
      eject,
      getXMLBlockly,
      getCodeChuckFromBlockly,
      undo,
      redo,
      configChuck,
      // -- triggers
      triggerConnectModal,
      closeConnecModal,
    };
  },
});
</script>

<style scoped>
div {
  /* TODO STYLE */
  background-color: #131516;
  /* background-image: url("https://images.unsplash.com/photo-1564500617448-e541b1df7cee?ixlib=rb-1.2.1&auto=format&fit=crop&w=1350&q=80");*/
  /* background-image: url("../assets/FocusMenu/photo-1564500617448-e541b1df7cee.webp?ixlib=rb-1.2.1&auto=format&fit=crop&w=1350&q=80");*/
  /* background: url(../assets/FocusMenu/banner_moon1.jpg); */
  background-size : cover;
  position: relative;
  padding: 0px 0px 0px 0px;
  top: 0px;
  margin: 0px 0px 0px 0px;
}

.ulMenu {
  position: relative;
  padding: 0px 0px 0px 0px;
  top: 0px;
  margin: 0px 0px 0px 0px;
  /* margin-left: -40px;*/
  width  : auto;
}

.liReturnMenu {
  list-style-type : none;
  /* TODO STYLE */
  background      : linear-gradient(rgba(220,220,255,0) 85%, rgba(255,255,255,0) 100%);
  text-align: center;
  /*display: inline-block;*/
  float   : left; /* left, right */
  cursor  : pointer;
  padding : 3px 10px;
  border-top    : 2px solid rgba(200,200,255,0.0);
  border-bottom : 2px solid rgba(50,50,50,0.0);
  padding: 2px 2px;
  margin: 0px 0px 0px 0px;
}

.returnMenu {
  position: fixed;
  padding: 0px 0px 0px 0px;
  left: 0px;
  margin: 0px 0px 0px 0px;
  border-radius : 3px;
}

.listMenu {
  position: fixed;
  padding: 0px 0px 0px 0px;
  right: 0px;
  margin: 0px 0px 0px 0px;
  border-radius : 3px;
  /*height: 200px; tamaño menu*/
}

.listMenu:after , .listMenu:before {
  display : block;
  content : " ";
}

.listMenu:after {
  clear : both;
}

li {
  list-style-type : none;
  /* TODO STYLE */
  background      : linear-gradient(rgba(220,220,255,0.1) 85%, rgba(255,255,255,0.5) 100%);
  text-align: center;
  /*display: inline-block;*/
  float   : left; /* left, right */
  cursor  : pointer;
  padding : 3px 10px;
  border-top    : 2px solid rgba(200,200,255,0.5);
  border-bottom : 2px solid rgba(50,50,50,0.4);
  padding: 2px 2px;
  margin: 0px 0px 0px 0px;
}

li:first-child {
  border-radius : 5px 0 0 5px;
}

li:last-child {
  border-radius : 0 5px 5px 0;
}

i {
  padding: 0px 0px;
  margin: 0px 0px 0px 0px;
}

a {
  display : block;
  text-align: center;
  line-height: 0.5;
  padding : 8px 8px; /* 10px 13px */
  font-size : 20px;   /* 26px */
  text-decoration : none;
  border-radius   : 20px;
  position        : relative;
  top   : 0;
  color : #FFF;
  transition : all .4s;
  z-index: 71;
}

span {
  display: inline-block;
  font-size: 12px;
  pointer-events: none;
  padding : 0px 0px;
  margin: 0px 0px 0px 0px;
}

/*li:hover a {*/
li:active a {
  /* TODO STYLE */
  top   : -5px; /* - arriba + abajo Desplazamiento al poner el cursor sobre el boton */
  color : black; /* color to convert skyBlue #4eacff*/
  background-color: #fff;
  box-shadow : 0 0 5px 0 rgba(255, 255, 255, 0.7);
  transition : all .1s;
  border-color : dark;
}

li a:after {
  display  : block;
  content  : "";
  position : relative;
  top  : 100%;
  left : 0%;
  border-style : solid;
  border-color : transparent;
  border-width : 5px 5px 0 5px;
  transition   : all .4s;
}

/*li:hover a:after {*/
li:active a:after {
  border-color : white transparent transparent transparent;
  transition   : all 0.7s;
}
</style>
